Ubuntu

bcmwl-kernel-source 6.20.155.1+bdcom-0ubuntu6: bcmwl kernel module failed to build on kernel 3.9 [wl_cfg80211.c:2025:3: error: too few arguments to function ‘cfg80211_put_bss’]

Reported by Cristian Aravena Romero on 2013-03-20
372
This bug affects 53 people
Affects Status Importance Assigned to Milestone
bcmwl (Ubuntu)
Undecided
Alberto Milone
Nominated for Raring by Daniel van Vugt

Bug Description

bcmwl-kernel-source (version): bcmwl kernel module failed to build on kernel (version) [wl_cfg80211.c:2025:3: error: too few arguments to function ‘cfg80211_put_bss’]

ORIGINAL DESCRIPTION:
upgrade to kernel :
http://kernel.ubuntu.com/~kernel-ppa/mainline/v3.9-rc3-raring/

ProblemType: Package
DistroRelease: Ubuntu 13.04
Package: bcmwl-kernel-source 6.20.155.1+bdcom-0ubuntu6
ProcVersionSignature: Ubuntu 3.8.0-13.23-generic 3.8.3
Uname: Linux 3.8.0-13-generic x86_64
NonfreeKernelModules: wl
ApportVersion: 2.9.2-0ubuntu1
Architecture: amd64
DKMSKernelVersion: 3.9.0-030900rc3-generic
Date: Wed Mar 20 15:09:28 2013
InstallationDate: Installed on 2013-02-06 (42 days ago)
InstallationMedia: Ubuntu 13.04 "Raring Ringtail" - Alpha amd64 (20121126)
MarkForUpload: True
PackageVersion: 6.20.155.1+bdcom-0ubuntu6
SourcePackage: bcmwl
Title: bcmwl-kernel-source 6.20.155.1+bdcom-0ubuntu6: bcmwl kernel module failed to build
UpgradeStatus: No upgrade log present (probably fresh install)

tags: removed: need-duplicate-check
summary: bcmwl-kernel-source 6.20.155.1+bdcom-0ubuntu6: bcmwl kernel module
- failed to build
+ failed to build [wl_cfg80211.c:2025:3: error: faltan argumentos para la
+ función ‘cfg80211_put_bss’]

same here running 3.9.0-999-generic #201303250405

DKMS make.log for bcmwl-6.20.155.1+bdcom for kernel 3.9.0-999-generic (x86_64)
Mo 25. Mär 17:26:23 CET 2013
make: Entering directory `/usr/src/linux-headers-3.9.0-999-generic'
CFG80211 API is prefered for this kernel version
Using CFG80211 API
  LD /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/built-in.o
  CC [M] /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/shared/linux_osl.o
  CC [M] /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_linux.o
  CC [M] /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_iw.o
  CC [M] /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.o
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:1578:2: warning: initialization from incompatible pointer type [enabled by default]
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:1578:2: warning: (near initialization for ‘wl_cfg80211_ops.set_tx_power’) [enabled by default]
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:1579:2: warning: initialization from incompatible pointer type [enabled by default]
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:1579:2: warning: (near initialization for ‘wl_cfg80211_ops.get_tx_power’) [enabled by default]
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c: In function ‘wl_update_bss_info’:
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:2025:3: warning: passing argument 1 of ‘cfg80211_put_bss’ from incompatible pointer type [enabled by default]
In file included from /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:33:0:
include/net/cfg80211.h:3302:6: note: expected ‘struct wiphy *’ but argument is of type ‘struct cfg80211_bss *’
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:2025:3: error: too few arguments to function ‘cfg80211_put_bss’
In file included from /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:33:0:
include/net/cfg80211.h:3302:6: note: declared here
make[1]: *** [/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.o] Error 1
make: *** [_module_/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build] Error 2
make: Leaving directory `/usr/src/linux-headers-3.9.0-999-generic'

Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in bcmwl (Ubuntu):
status: New → Confirmed
Gökçen Eraslan (gkcn) wrote :
summary: bcmwl-kernel-source 6.20.155.1+bdcom-0ubuntu6: bcmwl kernel module
- failed to build [wl_cfg80211.c:2025:3: error: faltan argumentos para la
- función ‘cfg80211_put_bss’]
+ failed to build on kernel 3.9 [wl_cfg80211.c:2025:3: error: faltan
+ argumentos para la función ‘cfg80211_put_bss’]
summary: bcmwl-kernel-source 6.20.155.1+bdcom-0ubuntu6: bcmwl kernel module
- failed to build on kernel 3.9 [wl_cfg80211.c:2025:3: error: faltan
- argumentos para la función ‘cfg80211_put_bss’]
+ failed to build on kernel 3.9 [wl_cfg80211.c:2025:3: error: too few
+ arguments to function ‘cfg80211_put_bss’]
Gökçen Eraslan (gkcn) wrote :

The attachment "add-support-for-linux-3.9.0.patch" seems to be a patch. If it isn't, please remove the "patch" flag from the attachment, remove the "patch" tag, and if you are a member of the ~ubuntu-reviewers, unsubscribe the team.

[This is an automated message performed by a Launchpad user owned by ~brian-murray, for any issues please contact him.]

tags: added: patch
cariboo907 (cariboo907) wrote :

I'd like to add that I'm seeing the same error on i386 architecture

Eugene San (eugenesan) wrote :

Based on provided patch, I've prepared fixed packages:
Raring: https://launchpad.net/~eugenesan/+archive/ppa/+sourcepub/3156599/+listing-archive-extra
Saucy: https://launchpad.net/~eugenesan/+archive/ppa/+sourcepub/3156603/+listing-archive-extra

Note: Driver more recent than official one, use it with caution.

Bernardo Reino (reinob) wrote :

@Eugene San,

Thanks for preparing the package. I will give it a try -- although I had already manually patched my driver, and although I'm running 12.04.

One thing I don't understand is what the difference may be between the version of saucy vs raring vs quantal vs precise. The "core" of the driver is kernel independent, while the rest of the driver depends on the kernel version (as we all have painfully experienced :).

But what can possibly be the dependence on the Ubuntu version?

We have now 2 or 3 bcmwl versions available for each Ubuntu release, causing an enormous number of (duplicate) bug reports which are all mixed around throughout launchpad. And then we get fixes which only apply to a specific version (e.g. driver fixed for kernel 3.9 but only for raring and saucy, but not for precise or quantal). We have ONE SINGLE driver, which needs patches for each kernel. That's already messy enough.

Given that we have patches for each kernel from at least 3.2 all the way (now) to 3.9, it would be nice if there was a single .deb for all releases. This way we could all focus our efforts in fixing or improving this one driver.

Download full text (3.2 KiB)

I can't install it :

baranovskiykonstantin@Lenovo-G550:~$ sudo dpkg -i
Загрузки/bcmwl-kernel-source_6.30.223.30+bdcom-0ubuntu1~eugenesan~raring1_i386.deb

[sudo] password for baranovskiykonstantin:
Выбор ранее не выбранного пакета bcmwl-kernel-source.
(Чтение базы данных … на данный момент установлено 315763 файла и каталога.)
Распаковывается пакет bcmwl-kernel-source (из файла
…/bcmwl-kernel-source_6.30.223.30+bdcom-0ubuntu1~eugenesan~raring1_i386.deb)

Настраивается пакет bcmwl-kernel-source
(6.30.223.30+bdcom-0ubuntu1~eugenesan~raring1) …
Loading new bcmwl-6.30.223.30+bdcom DKMS files...
First Installation: checking all kernels...
Building only for 3.9.0-0-generic
Building for architecture i686
Building initial module for 3.9.0-0-generic
ERROR (dkms apport): kernel package linux-headers-3.9.0-0-generic is not
supported
Error! Bad return status for module build on kernel: 3.9.0-0-generic (i686)
Consult /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/make.log for more
information.
FATAL: Module wl not found.
update-initramfs: deferring update (trigger activated)
Обрабатываются триггеры для initramfs-tools …
update-initramfs: Generating /boot/initrd.img-3.9.0-0-generic/онстантин/

make.log:

DKMS make.log for bcmwl-6.30.223.30+bdcom for kernel 3.9.0-0-generic (i686)
Суб Май 4 08:18:08 EEST 2013
make: Вход в каталог `/usr/src/linux-headers-3.9.0-0-generic'
CFG80211 API is prefered for this kernel version
Using CFG80211 API
   LD /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/built-in.o
   CC [M] /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/shared/linux_osl.o
   CC [M] /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.o
   CC [M] /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_iw.o
   CC [M]
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.o
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.c:
В функции «wl_update_bss_info»:
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.c:2051:3:
предупреждение: в передаче аргумента 1 «cfg80211_put_bss»: несовместимый
тип указателя [по умолчанию включена]Distributor ID: Ubuntu
Description: Ubuntu 13.04
Release: 13.04
Codename: raring
Linux Lenovo-G550 3.9.0-0-generic #4-Ubuntu SMP Thu May 2 21:43:10 UTC
2013 i686 i686 i686 GNU/Linux
In file included from
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.c:33:0:
include/net/cfg80211.h:3302:6: замечание: expected «struct wiphy *» but
argument is of type «struct cfg80211_bss *»
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.c:2051:3:
ошибка: слишком мало аргументов в вызове функции «cfg80211_put_bss»
In file included from
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.c:33:0:
include/net/cfg80211.h:3302:6: замечание: declared here
make[1]: ***
[/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.o]
Ошибка 1
make: *** [_module_/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build] Ошибка 2
make: Выход из каталога `/usr/src/linux-headers-3.9.0-0-generic'

System:

Distributor ID: Ubuntu
Description: Ubuntu 13.04
Release: 13.04
Codename: rari...

Read more...

Jairo Serrano (jairo-serrano) wrote :

cat /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/make.log
DKMS make.log for bcmwl-6.30.223.30+bdcom for kernel 3.9.0-030900-generic (x86_64)
dom may 5 12:51:25 COT 2013
make: se ingresa al directorio «/usr/src/linux-headers-3.9.0-030900-generic»
CFG80211 API is prefered for this kernel version
Using CFG80211 API
  LD /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/built-in.o
  CC [M] /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/shared/linux_osl.o
  CC [M] /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.o
  CC [M] /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_iw.o
  CC [M] /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.o
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.c: En la función ‘wl_update_bss_info’:
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.c:2051:3: aviso: se pasa el argumento 1 de ‘cfg80211_put_bss’ desde un tipo de puntero incompatible [activado por defecto]
In file included from /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.c:33:0:
include/net/cfg80211.h:3302:6: nota: se esperaba ‘struct wiphy *’ pero el argumento es de tipo ‘struct cfg80211_bss *’
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.c:2051:3: error: faltan argumentos para la función ‘cfg80211_put_bss’
In file included from /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.c:33:0:
include/net/cfg80211.h:3302:6: nota: se declara aquí
make[1]: *** [/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_cfg80211_hybrid.o] Error 1
make: *** [_module_/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build] Error 2
make: se sale del directorio «/usr/src/linux-headers-3.9.0-030900-generic»

Bernardo Reino (reinob) wrote :

@Baranovskiy Konstantin and Jairo Serrano,

On the top of this page you can click "this bug affects me too". The error message is (now) well known, so at least IMHO nobody needs additional translations[*] of these messages.

[*] RANT: How is it possible that the make and gcc spit translated messages? This is absolutely crazy. What's next, a localized kernel log?

Leif Sawyer (ak.hepcat) wrote :

Confirmed that the patch listed above does not solve the full extent of the problem.

It does allow the module to build, but then any use of the network will cause the kernel to OOPS.
Only a hard-power-cycle will restore access to the system, provided you boot into single-user mode to remove the module prior to system usage.

Gökçen Eraslan (gkcn) wrote :

I use it flawlessly on Raring with Broadcom 4331.

bjaglin (bjaglin) wrote :

The ppa provided in #8 doesn't work out of the box, because the add-support-for-linux-3.9.0 patch isn't actually applied by DKMS, as reported earlier, in #10 and #11.

After the failure, add the following line to /var/lib/dkms/bcmwl/6.30.223.30+bdcom/source/dkms.conf:
PATCH[5]="0008-add-support-for-linux-3.9.0.patch"

And re-configure the package:
$ sudo dpkg-reconfigure bcmwl-kernel-source

bjaglin (bjaglin) wrote :

Actually this was fixed in the ppa itself, in the following versions of the packages, which was simply not linked from here:

so instead of the links in #8, use the newer versions:
saucy: https://launchpad.net/~eugenesan/+archive/ppa/+sourcepub/3158236/+listing-archive-extra
raring: https://launchpad.net/~eugenesan/+archive/ppa/+sourcepub/3158235/+listing-archive-extra
precise: https://launchpad.net/~eugenesan/+archive/ppa/+sourcepub/3158234/+listing-archive-extra

Thomas H St.Clair (thstclair) wrote :

@bjaglin: the "new" version for saucy worked! It DID build...Until I rebooted and found that all wireless extensions were unavailable. There is something here that does not persist in working. FWIW I've got a Broadcom Corporation BCM4322 802.11a/b/g/n Wireless LAN Controller [14e4:432b] (rev 01).

mlassnig (mario-lassnig) wrote :

@thstclair The same happens to me on linux-3.9 with a bcm4331. With the patch and the correct dkms.conf it builds and installs the module, the module is modprobed correctly, but there are simply no WiFi extensions available (no wlan0 or similar). Also, no kernel oops/panics anything. Just nothing.

Changed in bcmwl (Ubuntu):
assignee: nobody → Alberto Milone (albertomilone)
Gökçen Eraslan (gkcn) wrote :

Can someone also look into the build problem on linux 3.10rc1 kernel? I think create_proc_entry must be replaced with a proc_create call. Here is the build log for 3.10rc1 mainline kernel:

DKMS make.log for bcmwl-6.30.223.30+bdcom for kernel 3.10.0-031000rc1-generic (x86_64)
Çrş May 15 11:22:13 CEST 2013
make: Entering directory `/usr/src/linux-headers-3.10.0-031000rc1-generic'
CFG80211 API is prefered for this kernel version
Using CFG80211 API
  LD /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/built-in.o
  CC [M] /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/shared/linux_osl.o
  CC [M] /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.o
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c: In function ‘wl_tkip_printstats’:
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3247:7: warning: passing argument 1 of ‘wl->tkipmodops->print_stats’ from incompatible pointer type [enabled by default]
       wl->tkip_bcast_data[idx]);
       ^
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3247:7: note: expected ‘struct seq_file *’ but argument is of type ‘char *’
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3250:4: warning: passing argument 1 of ‘wl->tkipmodops->print_stats’ from incompatible pointer type [enabled by default]
    wl->tkipmodops->print_stats(debug_buf, wl->tkip_ucast_data);
    ^
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3250:4: note: expected ‘struct seq_file *’ but argument is of type ‘char *’
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c: In function ‘wl_reg_proc_entry’:
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3471:2: error: implicit declaration of function ‘create_proc_entry’ [-Werror=implicit-function-declaration]
  if ((wl->proc_entry = create_proc_entry(tmp, 0644, NULL)) == NULL) {
  ^
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3471:22: warning: assignment makes pointer from integer without a cast [enabled by default]
  if ((wl->proc_entry = create_proc_entry(tmp, 0644, NULL)) == NULL) {
                      ^
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3476:16: error: dereferencing pointer to incomplete type
  wl->proc_entry->read_proc = wl_proc_read;
                ^
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3477:16: error: dereferencing pointer to incomplete type
  wl->proc_entry->write_proc = wl_proc_write;
                ^
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3478:16: error: dereferencing pointer to incomplete type
  wl->proc_entry->data = wl;
                ^
cc1: some warnings being treated as errors
make[1]: *** [/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.o] Error 1
make: *** [_module_/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build] Error 2
make: Leaving directory `/usr/src/linux-headers-3.10.0-031000rc1-generic'

Changed in bcmwl (Ubuntu):
status: Confirmed → In Progress
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package bcmwl - 6.30.223.30+bdcom-0ubuntu1

---------------
bcmwl (6.30.223.30+bdcom-0ubuntu1) saucy; urgency=low

  * New upstream release.
  * debian/dkms.conf.in:
    - Drop patches for Linux 3.2 and 3.4.
  * 0006-add-support-for-linux-3.8.0.patch,
    0007-nl80211-move-scan-API-to-wdev.patch:
    - Refresh against new release.
  * 0008-add-support-for-linux-3.9.0.patch:
    - Add support for Linux 3.9 (LP: #1157880).
 -- Alberto Milone <email address hidden> Wed, 15 May 2013 13:11:43 +0200

Changed in bcmwl (Ubuntu):
status: In Progress → Fix Released
Vistaus (djmusic121) wrote :

This still isn't fixed. Even with the 6.30 firmware I still don't have wireless network. My card is Broadcom 4331. Can someone reopen this please?

Alberto Milone (albertomilone) wrote :

@Vistaus: the issue dealt with in this bug report is the following: "bcmwl kernel module failed to build". The module doesn't fail to build against Linux 3.9 any more. If you're experiencing a different issue, please file a separate bug report.

l3iggs (l3iggs) wrote :

i'm still seeing the issue:
make: Entering directory `/usr/src/linux-headers-3.9.3-030903-generic'
CFG80211 API is prefered for this kernel version
Using CFG80211 API
  LD /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/built-in.o
  CC [M] /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/shared/linux_osl.o
  CC [M] /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_linux.o
  CC [M] /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_iw.o
  CC [M] /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.o
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:1578:2: warning: initialization from incompatible pointer type [enabled by default]
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:1578:2: warning: (near initialization for ‘wl_cfg80211_ops.set_tx_power’) [enabled by default]
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:1579:2: warning: initialization from incompatible pointer type [enabled by default]
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:1579:2: warning: (near initialization for ‘wl_cfg80211_ops.get_tx_power’) [enabled by default]
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c: In function ‘wl_update_bss_info’:
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:2025:3: warning: passing argument 1 of ‘cfg80211_put_bss’ from incompatible pointer type [enabled by default]
include/net/cfg80211.h:3302:6: note: expected ‘struct wiphy *’ but argument is of type ‘struct cfg80211_bss *’
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:2025:3: error: too few arguments to function ‘cfg80211_put_bss’
include/net/cfg80211.h:3302:6: note: declared here
make[1]: *** [/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.o] Error 1
make: *** [_module_/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build] Error 2
make: Leaving directory `/usr/src/linux-headers-3.9.3-030903-generic'

Marji Cermak (cermakm) wrote :

I can confirm that bcmwl-kernel-source 6.20.155.1+bdcom-0ubuntu6 DOES NOT build for kernel 3.9.4:

$ cat /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/make.log
DKMS make.log for bcmwl-6.20.155.1+bdcom for kernel 3.9.4-030904-generic (x86_64)
Mon May 27 23:14:09 EST 2013
make: Entering directory `/usr/src/linux-headers-3.9.4-030904-generic'
CFG80211 API is prefered for this kernel version
Using CFG80211 API
  LD /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/built-in.o
  CC [M] /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/shared/linux_osl.o
  CC [M] /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_linux.o
  CC [M] /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_iw.o
  CC [M] /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.o
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:1578:2: warning: initialization from incompatible pointer type [enabled by default]
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:1578:2: warning: (near initialization for ‘wl_cfg80211_ops.set_tx_power’) [enabled by default]
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:1579:2: warning: initialization from incompatible pointer type [enabled by default]
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:1579:2: warning: (near initialization for ‘wl_cfg80211_ops.get_tx_power’) [enabled by default]
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c: In function ‘wl_update_bss_info’:
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:2025:3: warning: passing argument 1 of ‘cfg80211_put_bss’ from incompatible pointer type [enabled by default]
In file included from /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:33:0:
include/net/cfg80211.h:3302:6: note: expected ‘struct wiphy *’ but argument is of type ‘struct cfg80211_bss *’
/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:2025:3: error: too few arguments to function ‘cfg80211_put_bss’
In file included from /var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.c:33:0:
include/net/cfg80211.h:3302:6: note: declared here
make[1]: *** [/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build/src/wl/sys/wl_cfg80211.o] Error 1
make: *** [_module_/var/lib/dkms/bcmwl/6.20.155.1+bdcom/build] Error 2
make: Leaving directory `/usr/src/linux-headers-3.9.4-030904-generic'

Marji Cermak (cermakm) wrote :

Apologies. I must be sleepy.

1) I forgot to mention in previous post #25 that I'm not running ubuntu 13.04, but 12.10 with bcmwl-kernel-source 6.20.155.1+bdcom-0ubuntu6 installed manualy (from 13.04).

2) when I actually install the saucy versions of bcmwl-kernel-source 6.30.223.30+bdcom-0ubuntu1 from https://launchpad.net/ubuntu/saucy/amd64/bcmwl-kernel-source/6.30.223.30+bdcom-0ubuntu1, it DOES builds properly with kernel 3.9.4.

3) This saucy version bcmwl-kernel-source 6.30.223.30+bdcom-0ubuntu1 DOES NOT build for kernel 3.10rc3. Here is the log:

cat /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/make.log
DKMS make.log for bcmwl-6.30.223.30+bdcom for kernel 3.10.0-031000rc3-generic (x86_64)
Mon May 27 23:53:17 EST 2013
make: Entering directory `/usr/src/linux-headers-3.10.0-031000rc3-generic'
CFG80211 API is prefered for this kernel version
Using CFG80211 API
  LD /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/built-in.o
  CC [M] /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/shared/linux_osl.o
  CC [M] /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.o
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c: In function ‘wl_tkip_printstats’:
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3247:7: warning: passing argument 1 of ‘wl->tkipmodops->print_stats’ from incompatible pointer type [enabled by default]
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3247:7: note: expected ‘struct seq_file *’ but argument is of type ‘char *’
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3250:4: warning: passing argument 1 of ‘wl->tkipmodops->print_stats’ from incompatible pointer type [enabled by default]
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3250:4: note: expected ‘struct seq_file *’ but argument is of type ‘char *’
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c: In function ‘wl_reg_proc_entry’:
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3471:2: error: implicit declaration of function ‘create_proc_entry’ [-Werror=implicit-function-declaration]
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3471:22: warning: assignment makes pointer from integer without a cast [enabled by default]
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3476:16: error: dereferencing pointer to incomplete type
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3477:16: error: dereferencing pointer to incomplete type
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3478:16: error: dereferencing pointer to incomplete type
cc1: some warnings being treated as errors
make[1]: *** [/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.o] Error 1
make: *** [_module_/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build] Error 2
make: Leaving directory `/usr/src/linux-headers-3.10.0-031000rc3-generic'

NVieville (nicolas-vieville) wrote :

Hello,

Actually, I get the 6.30.223.30 device driver built on Fedora Rawhide with wl-6xx-kmod-011_kernel_3.10.patch applied on the same sources of the Ubuntu package. Maybe some adjustment have to be done against this patch, as I also apply other patches for Fedora on these sources.
As I don't use actually the 3.10 kernel series (professional laptop), I can't say if this patch is working on a live 3.10 kernel. I can only say that the device driver compiles.

Hope this will help to improve this package against 3.10 kernels.

Cordially,

--
NVieville

Thomas H St.Clair (thstclair) wrote :

@NVieville: how does one go about applying this patch to the bcmwl-XXXX.deb? Possible?

FWIW the newer deb works and builds against 3.9 kernel, but using 3.10 these days and same story as before.

Thanks, Tom

NVieville (nicolas-vieville) wrote :

@Thomas H St.Clair:
The patch needs to be applied on the sources tree of the device driver while building the .deb package. As my current laptop runs Fedora only, and as for the moment I can't get an Ubuntu machine with all the build environment needed, you need a generous developer in this thread to check if the patch applies correctly in the current sources tree of the Ubuntu package (see my comment #27) and to build the package for you.

Sorry for that!
Maybe you should try to build it yourself by following instructions displayed here: http://developer.ubuntu.com/packaging/html/index.html

Maybe I could get an Ubuntu machine the next few days, and try to build it, but that's not 100% sure.

Cordially,

--
NVieville

NVieville (nicolas-vieville) wrote :

Hello,

@Thomas H St.Clair:

While reading this thread comment:

https://bugs.launchpad.net/ubuntu/+source/broadcom-sta/+bug/1101963/comments/10

I thought, it would be worth trying this method (with some adaptation) to get the 6.30.223.30 driver rebuilt with the kernel 3.10 patch in the dkms package.

Hope this will help you to get this driver working in kernel 3.10.x. If you get it working, I would be grateful if you could post some feedback about how it works.

Cordially,

--
NVieville

Thomas H St.Clair (thstclair) wrote :

@NVieville ,

Tried the patch...couldn't get bcml-blah,blah to re-build. BUT meanwhile a new bcml-blah,blah has been released which is patched to work with x.3.10.X and does work and build, its v2 of the old pkg. Problem now is that it does not work on a custom kernel. Normal kernels from Ubuntu do, however.

HTH,
Tom

Karachun Eugene (karachungen) wrote :

Have same problem. Compiling driver by hands helped me. See Romero`s method there http://forums.fedoraforum.org/archive/index.php/t-280821.html

1) get the source files from broadcom -- http://www.broadcom.com/docs/linux_sta/hybrid-portsrc_x86_64-v5_100_82_112.tar.gz

2) make a new directory and extract the source files
# mkdir hybrid-wl
# cd hydrid-wl
# tar -xvzf ../hybrid-portsrc_x86_64-v5_100_82_112.tar.gz

3) change to the problematic file directory
# cd src/wl/sys

4) fix the source file wl_linux.c (of course use your favourite editor):
# vi wl_linux.c
around line 43, remove the line
#include <asm/system.h>

search for the string
.ndo_set_multicast_list
and replace it with
.ndo_set_rx_mode

save the file, and try to compile

5) # cd ../../..
# make

If you are lucky things should work, and you'll have a file called "wl.ko" in the current directory. (I got these patches from the internet, not my own work.)

I then did

# mkdir -p /lib/modules/3.4.0-1.fc17.x86_64/extra/wl
# cp wl.ko /lib/modules/3.4.0-1.fc17.x86_64/extra/wl
# depmod -a
# modprobe wl

and I had to reconfigure the interface, inserting the network password again, but after that it's working.

Hello Karachun Eugene (karachungen),

This solution fails on kernel 3.10:

make[1]: ingresso nella directory "/usr/src/linux-headers-3.10.0-031000-generic"
Wireless Extension is the only possible API for this kernel version
Using Wireless Extension API
  CC [M] /home/marco/Scrivania/src/wl/sys/wl_linux.o
/home/marco/Scrivania/src/wl/sys/wl_linux.c: In function ‘wl_tkip_printstats’:
/home/marco/Scrivania/src/wl/sys/wl_linux.c:2970:7: warning: passing argument 1 of ‘wl->tkipmodops->print_stats’ from incompatible pointer type [enabled by default]
/home/marco/Scrivania/src/wl/sys/wl_linux.c:2970:7: note: expected ‘struct seq_file *’ but argument is of type ‘char *’
/home/marco/Scrivania/src/wl/sys/wl_linux.c:2973:4: warning: passing argument 1 of ‘wl->tkipmodops->print_stats’ from incompatible pointer type [enabled by default]
/home/marco/Scrivania/src/wl/sys/wl_linux.c:2973:4: note: expected ‘struct seq_file *’ but argument is of type ‘char *’
/home/marco/Scrivania/src/wl/sys/wl_linux.c: In function ‘wl_reg_proc_entry’:
/home/marco/Scrivania/src/wl/sys/wl_linux.c:3180:2: error: implicit declaration of function ‘create_proc_entry’ [-Werror=implicit-function-declaration]
/home/marco/Scrivania/src/wl/sys/wl_linux.c:3180:22: warning: assignment makes pointer from integer without a cast [enabled by default]
/home/marco/Scrivania/src/wl/sys/wl_linux.c:3185:16: error: dereferencing pointer to incomplete type
/home/marco/Scrivania/src/wl/sys/wl_linux.c:3186:16: error: dereferencing pointer to incomplete type
/home/marco/Scrivania/src/wl/sys/wl_linux.c:3187:16: error: dereferencing pointer to incomplete type
cc1: some warnings being treated as errors
make[2]: *** [/home/marco/Scrivania/src/wl/sys/wl_linux.o] Errore 1
make[1]: *** [_module_/home/marco/Scrivania] Errore 2
make[1]: uscita dalla directory "/usr/src/linux-headers-3.10.0-031000-generic"

Same problem with bcmwl-6.30.223.30+bdcom-0ubuntu1:

DKMS make.log for bcmwl-6.30.223.30+bdcom for kernel 3.10.0-031000-generic (x86_64)
gio 4 lug 2013, 23.20.25, CEST
make: ingresso nella directory "/usr/src/linux-headers-3.10.0-031000-generic"
CFG80211 API is prefered for this kernel version
Using CFG80211 API
  LD /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/built-in.o
  CC [M] /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/shared/linux_osl.o
  CC [M] /var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.o
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c: In function ‘wl_tkip_printstats’:
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3247:7: warning: passing argument 1 of ‘wl->tkipmodops->print_stats’ from incompatible pointer type [
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3247:7: note: expected ‘struct seq_file *’ but argument is of type ‘char *’
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3250:4: warning: passing argument 1 of ‘wl->tkipmodops->print_stats’ from incompatible pointer type [
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3250:4: note: expected ‘struct seq_file *’ but argument is of type ‘char *’
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c: In function ‘wl_reg_proc_entry’:
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3471:2: error: implicit declaration of function ‘create_proc_entry’ [-Werror=implicit-function-declar
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3471:22: warning: assignment makes pointer from integer without a cast [enabled by default]
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3476:16: error: dereferencing pointer to incomplete type
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3477:16: error: dereferencing pointer to incomplete type
/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.c:3478:16: error: dereferencing pointer to incomplete type
cc1: some warnings being treated as errors
make[1]: *** [/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build/src/wl/sys/wl_linux.o] Errore 1
make: *** [_module_/var/lib/dkms/bcmwl/6.30.223.30+bdcom/build] Errore 2
make: uscita dalla directory "/usr/src/linux-headers-3.10.0-031000-generic"

Cordially,

Thomas H St.Clair (thstclair) wrote :

From my experience: bcmwl-kernel-source_6.30.223.30+bdcom-0ubuntu2_amd64.deb works and builds on an Ubuntu "stock 3.10.X kernel (not bcmwl-kernel-source_6.30.223.30+bdcom-0ubuntu1_amd64.deb) . bcmwl-kernel-source_6.30.223.30+bdcom-0ubuntu3_amd64.deb works and builds on a custom 3.10.X kernel without a low latency desktop kernel config. you ought to try one of those versions. should be able to find them easily through a simple search. HTH

description: updated
Redstorm (spencer-roff) wrote :

dmesg has a couple of errors this is on Ubuntu stock 3.10.9-031009-generic but it builds and is available, i haven't tested it though.

[391416.044759] cfg80211: Calling CRDA to update world regulatory domain
[391416.045821] lib80211: common routines for IEEE802.11 drivers
[391416.045823] lib80211_crypt: registered algorithm 'NULL'
[391416.049249] wl: module license 'MIXED/Proprietary' taints kernel.
[391416.049252] Disabling lock debugging due to kernel taint
[391416.051071] cfg80211: World regulatory domain updated:
[391416.051074] cfg80211: (start_freq - end_freq @ bandwidth), (max_antenna_gain, max_eirp)
[391416.051076] cfg80211: (2402000 KHz - 2472000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
[391416.051077] cfg80211: (2457000 KHz - 2482000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
[391416.051078] cfg80211: (2474000 KHz - 2494000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
[391416.051079] cfg80211: (5170000 KHz - 5250000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
[391416.051080] cfg80211: (5735000 KHz - 5835000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
[391416.068836] femctrl from nvram not enabled. returning from here
[391416.070263] INFO @wl_cfg80211_attach : Registered CFG80211 phy
[391416.072313] lib80211_crypt: registered algorithm 'TKIP'
[391416.100322] eth1: Broadcom BCM43b1 802.11 Hybrid Wireless Controller 6.30.223.30 (r390414)
[391459.775615] ERROR @wl_dev_intvar_get : error (-1)
[391459.775624] ERROR @wl_cfg80211_get_tx_power : error (-1)
[391534.088131] ERROR @wl_dev_intvar_get : error (-1)
[391534.088141] ERROR @wl_cfg80211_get_tx_power : error (-1)

Eric B (ebischoff) wrote :

The following error is still there on saucy :

src/wl/sys/wl_linux.c:3237:7: warning: passing argument 1 of ‘wl->tkipmodops->print_stats’ from incompatible pointer type [enabled by default]
       wl->tkip_bcast_data[idx]);
       ^
src/wl/sys/wl_linux.c:3237:7: note: expected ‘struct seq_file *’ but argument is of type ‘char *’

(see comments #20 and #34)

(yes, I know, this bug report is about raring, not saucy...)

Purinda Gunasekara (purinda) wrote :

Try the patch submitted in this bug #1197586

To post a comment you must log in.